<?
  /*
    admin php functions
  */

  function assert_mat_owner($material,$owner,$connection)
  {
    $query = "select id from materials where id = '$material' and
      userID = '$owner'";
    $result = query_redirect($query,$connection);
    assert_num_rows($result,1);
  }

  function assert_trait_owner($trait,$material,$owner,$connection)
  {
    $query = "select id from traits where materialID = '$material' and
      userID = '$owner' and table_name = '$trait'";
    $result = query_redirect($query,$connection);
    assert_num_rows($result,1);
  }

  function assert_mat_editable($material,$owner,$connection)
  {
    $query = "select id from materials where id = '$material' and
      (userID = '$owner' or mat_private = '0')";
    $result = query_redirect($query,$connection);
    assert_num_rows($result,1);
  }

  /*
    Deletes all traits associated with $material not owned by $owner
    if $owner is -1, then delete all traits associated with $material
    regardless of the owner. THIS ASSUMES THAT $owner owns $material!
  */
  function delete_traits($material, $owner, $connection)
  {
    /*
      First, remap the traits that point to this trait to themselves
      such that their value is a copy of this trait.
      This operation is irrelevant of the trait or material owner
    */
    $query = "select * from traits where table_materialID = '$material'
      and materialID != '$material'";
    $result = query_redirect($query,$connection);
    $traitarr = array();
    while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
      $query = "update traits set table_materialID = materialID where
        id = '${row["id"]}'";
      query_redirect($query,$connection);
      if(!isset($traitarr[$row["table_name"]])) {
        $query2 = "select * from `${row["table_name"]}` where id = '$material'";
        $result2 = query_redirect($query2,$connection);
        assert_num_rows($result2,1);
        foreach(mysql_fetch_array($result2,MYSQL_ASSOC) as $key => $value)
          $traitarr[$row["table_name"]][$key] = $value;
      }
      $query = "update `${row["table_name"]}` set ";
      $count = 0;
      foreach($traitarr[$row["table_name"]] as $key => $value) {
        if($key != "id" && $key != "timestamp") {
          if($count++ != 0)
            $query .= ",";
          $query .= "$key = '$value' ";
        }
      }
      $query .= ", timestamp = now() where id = '${row["materialID"]}'";
      query_redirect($query,$connection);
      assert_affected_rows($connection,1);
    }

    $query = "select * from traits where materialID = '$material'";
    if($owner != -1)
      $query .= " and userID != '${_SESSION["uid"]}'";

    $result = query_redirect($query,$connection);
    while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
      $query = "delete from `${row["table_name"]}` where
        id = '$material'";
      query_redirect($query,$connection);
    }
    $query = "delete from traits where materialID = '$material'";
    if($owner != -1)
      $query .= " and userID != '${_SESSION["uid"]}'";
    query_redirect($query,$connection);
  }

  /*
    Return true iff $material is cyclic w.r.t. $rel
  */
  function cyclic_material($traits,$material,$rel)
  {
    $traits[$material]["mark"] = true;
    //terminal link is when materialID == table_materialID
//print("material: $material, rel: $rel\n");
    while($material != $rel) {
      $material = $rel;
      $rel = $traits[$material]["table_materialID"];
      if(isset($traits[$material]["mark"])) {
//        print("mark found on material: $material returning true\n");
        return true;
      }

//print("material: $material, rel: $rel\n");
      $traits[$material]["mark"] = true;
    }
//print("material $material not cyclic wrt rel $rel, returning false\n");
    return false;
  }

  /*
    Function to obtain the materials associated with $trait
    either owned by $uid or are non-private that do not form a 
    cicular material reference with $material The return value is an array
    of materialIDs or an empty array if there are none
  */
  function get_available_materials($trait, $material, $uid, $connection)
  {
    $avail = array();
    $traits = array();

    //Capture all visible traits
    $query = "select id,materialID,table_materialID from traits where
      (userID = '$uid' or trait_private = '0') and table_name = '$trait'";

    $result = query_redirect($query,$connection);
    while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
      $traits[$row["materialID"]] = $row;
    }

    foreach($traits as $key => $value) {
      //it is always safe to assign to yourself
      if($key != $material && !cyclic_material($traits,$material,$key))
        $avail[] = $key;
    }

    return $avail;
  }

  function update_traits($material,$connection)
  {
    //first get the traits that we can access...
    $query = "select distinct table_name from traits where
      (trait_private = '0' or userID = ${_SESSION["uid"]})
      and materialID = $material";

    $result = query_redirect($query,$connection);
    while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
      $trait = $row["table_name"];
      $trait_link = urlencode($trait) . "_link";
      $trait_select = urlencode($trait) . "_select";

      if(!isset($_REQUEST[$trait_select])) {
        if(!isset($_REQUEST[$trait_link])) {
          //user just updated value field with link unchecked

          //first capture the sub-elements of the trait value
          $query = "select * from `$trait` where id = '$material'";
          $result2 = query_redirect($query,$connection);
          assert_num_rows($result2,1);
          $elem = mysql_fetch_array($result2,MYSQL_ASSOC);
          unset($elem["timestamp"]);
          unset($elem["id"]);
          $query = "update `$trait` set";
          foreach($elem as $key => $value) {
            $encoded_trait = urlencode($trait);
            if(isset($_REQUEST["${encoded_trait}_${key}"]))
              $query .= " $key = '${_REQUEST["${encoded_trait}_${key}"]}',";
          }
          $query .= " timestamp = now() where id = '$material'";

          query_redirect($query,$connection);
          if(mysql_affected_rows($connection) > 1) {
            session_write_close();
            header("Location: http://mater.brlcad.org/error/server_error.html?admin_inc=153");
            exit;
          }
        }
        else {
          //user just checked link,
          //so value field still has stuff in it. We must check for circular
          //links here!
          
          //get the list of materials we can safely link to from $material
          $available = get_available_materials($trait,$material,
            $_SESSION["uid"],$connection);

          //set ourself to the last choice
          $available[] = $material;

          if($available[0] == $material) {
            $_SESSION["update_error"] = $material;
            $_SESSION["update_error_msg"] = "You cannot select any other material. Check for cyclic material references.";
          }
          else {
            $query = "select trait_private from traits
              where materialID = '${available[0]}' and table_name = '$trait'";
            $result = query_redirect($query,$connection);
            assert_num_rows($result,1);
            $priv_row = mysql_fetch_array($result,MYSQL_ASSOC);
            $priv_state = $priv_row["trait_private"];

            $query = "update traits set table_materialID = '${available[0]}',
              trait_private = $priv_state where materialID = '$material'
              and table_name = '$trait'";

            query_redirect($query,$connection);
          }
        }
      }
      else
      {
        if(!isset($_REQUEST[$trait_link])) {
          //user unchecked link box
          $query = "update traits set table_materialID = '$material' where
            materialID = '$material' and table_name = '$trait' and
            userID = '${_SESSION["uid"]}'";

          query_redirect($query,$connection);
          $affected = mysql_affected_rows($connection);
          if($affected != 1) {
            session_write_close();
            header("Location: http://mater.brlcad.org/error/server_error.html");
            exit;
          }
        }
        else {
          //user switched the material drop down with
          //link checked. We much check for circular material links here!

          //get the list of materials we can safely link to from $material
          $available = get_available_materials($trait,$material,
            $_SESSION["uid"],$connection);

          //We can always link to ourself
          $available[] = $material;

          $selected = $_REQUEST[$trait_select];
          if(array_search($selected,$available) === false) {
            $_SESSION["update_error"] = $material;
            $_SESSION["update_error_msg"] = "You cannot link to this material";

            $selected = $material;
          }
          else {
            $query = "select trait_private from traits
              where materialID = '$selected' and table_name = '$trait'";

            $result = query_redirect($query,$connection);
            assert_num_rows($result,1);
            $priv_row = mysql_fetch_array($result,MYSQL_ASSOC);
            $priv_state = $priv_row["trait_private"];

            $query = "update traits set table_materialID = '$selected',
              trait_private = $priv_state  where materialID = '$material'
              and table_name = '$trait'";

            query_redirect($query,$connection);
          }
        }
      }
    }
  }

  function update_material($material,$connection)
  {
    if($material == "new") {
      //just create a new material and return but first make sure unique name
      $count = 1;
      $name = "unknown material";
      $found = true;
      while($found) {
        $query = "select id from materials where name = '$name'";
        if(mysql_num_rows(query_redirect($query,$connection)) > 0)
          $name = "unknown material " . $count++;
        else
          $found = false;
      }
      $query = "insert into materials values(DEFAULT,'$name',
        '${_SESSION["uid"]}','0','material description','${_SESSION["uid"]}',
        now())";
      query_redirect($query,$connection);
      assert_affected_rows($connection,1);

      session_write_close();
      header("Location: http://mater.brlcad.org/admin/admin.php");
      exit;
    }
    else if(!isset($_REQUEST["action"]))
      return;

    reset_session_vars();

    if($_REQUEST["action"] == "update") {
      if(isset($_REQUEST["modify"])) {
        assert_mat_owner($material,$_SESSION["uid"],$connection);
        //check to see if the name is unique
        $query = "select name from materials
          where name = '${_REQUEST["modify"]}'";
        $result = query_redirect($query,$connection);
        if(mysql_num_rows($result) != 0) {
          $_SESSION["update_error"] = $material;
          $_SESSION["update_error_msg"] =
            "'${_REQUEST["modify"]}' is already taken. Choose another.";
        }
        else {
          $query = "update materials set name = '${_REQUEST["modify"]}' where
            id = '$material'";
          query_redirect($query,$connection);
        }
      }
      else if(isset($_REQUEST["description"])) {
        //First strip all trailing newlines...
        $desc = rtrim($_REQUEST["description"]);
        $query = "update materials set description =
          '$desc', desc_author = '${_SESSION["uid"]}'
          where id = '$material'";
        query_redirect($query,$connection);
      }
      else
       update_traits($material,$connection);
    }
    else if($_REQUEST["action"] == "mat_public") {
      assert_mat_owner($material,$_SESSION["uid"],$connection);
      $query = "update materials set mat_private = !mat_private where
        id = '$material' and userID = '${_SESSION["uid"]}'";
      query_redirect($query,$connection);
      if(mysql_affected_rows($connection) != 1) {
        session_write_close();
        header("Location: http://mater.brlcad.org/error/server_error.html?159");
        exit;
      }
    }
    else if($_REQUEST["action"] == "mat_private") {
      assert_mat_owner($material,$_SESSION["uid"],$connection);
      $query = "select id from traits where table_materialID = '$material' and
        userID != '${_SESSION["uid"]}'";
      $no_conf = (mysql_num_rows(query_redirect($query,$connection)) == 0);
      if(!$no_conf && !isset($_REQUEST["confirm"])) {
        $_SESSION["state"] = "confirm";
        $_SESSION["meta"] = array("material" => $material,
          "action" => "mat_private");

        session_write_close();
        header("Location: http://mater.brlcad.org/admin/admin.php");
        exit;
      }
      else {
        if($no_conf || $_REQUEST["confirm"] == "1") {
          delete_traits($material,$_SESSION["uid"],$connection);

          $query = "update materials set mat_private = !mat_private where
            id = '$material' and userID = '${_SESSION["uid"]}'";
          query_redirect($query,$connection);
          if(mysql_affected_rows($connection) != 1) {
            session_write_close();
            header("Location: http://mater.brlcad.org/error/server_error.html?135");
            exit;
          }
        }
      }
    }
    else if($_REQUEST["action"] == "modify") {
      assert_mat_owner($material,$_SESSION["uid"],$connection);
      if(!isset($_REQUEST["name"]))
        $_SESSION["modify"] = $material;
    }
    else if($_REQUEST["action"] == "delete_mat") {
      assert_mat_owner($material,$_SESSION["uid"],$connection);
      $query = "select id from traits where table_materialID = '$material' and
        userID != '${_SESSION["uid"]}'";
      $no_conf = (mysql_num_rows(query_redirect($query,$connection)) == 0);
      if(!$no_conf && !isset($_REQUEST["confirm"])) {
        $_SESSION["state"] = "confirm";
        $_SESSION["meta"] = array("material" => $material,
          "action" => "delete_mat");

        session_write_close();
        header("Location: http://mater.brlcad.org/admin/admin.php");
        exit;
      }
      else {
        if($no_conf || $_REQUEST["confirm"] == "1") {
          delete_traits($material,-1,$connection);
          $query = "delete from materials where id ='$material'";
          query_redirect($query,$connection);
          if(mysql_affected_rows($connection) != 1) {
            session_write_close();
            header("Location: http://mater.brlcad.org/error/server_error.html?admin.inc=212");
            exit;
          }
        }
      }
    }
    else if($_REQUEST["action"] == "copy_mat") {
      $query = "select * from materials where id = '$material'";
      $result = query_redirect($query,$connection);
      assert_num_rows($result,1);

      $contents = mysql_fetch_array($result,MYSQL_ASSOC);

      //make sure we get a unique name first
      $done = false;
      $suffix = " copy";
      while(!$done) {
        $name = $contents["name"] . $suffix;
        $query = "select id from materials where name = '$name'";
        $next = query_redirect($query,$connection);
        $done = (mysql_num_rows($next) == 0);
        if(!$done)
          $suffix .= " copy";
      }

      $query = "insert into materials values(DEFAULT";
      foreach($contents as $key => $value) {
        if($key != "id") {
          if($key == "name")
            $value = $name;
          else if($key == "userID")
            $value = $_SESSION["uid"];
          $query .= ",'" . mysql_real_escape_string($value) . "'";
        }
      }
      $query .= ")";
      query_redirect($query,$connection);
      if(mysql_affected_rows($connection) != 1) {
        session_write_close();
        header("Location: http://mater.brlcad.org/error/server_error.html?admin.inc=226");
        exit;
      }
      $id = mysql_insert_id($connection);
      $query = "select * from traits where materialID = '$material' and
        (trait_private = '0' or userID = '${_SESSION["uid"]}')";
      $result = query_redirect($query,$connection);
      
      $tables = array();
      while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
        $query = "insert into traits values(DEFAULT";
        foreach($row as $key => $value) {
          if($key != "id") {
            if($key == "materialID")
              $value = $id;
            else if($key == "userID")
              $value = $_SESSION["uid"];
            else if($key == "table_name")
              $tables[] = $value;

            $query .= ",'" . mysql_real_escape_string($value) . "'";
          }
        }
        $query .= ")";
        query_redirect($query,$connection);
        assert_affected_rows($connection,1);
      }

      foreach($tables as $trait) {
        $query = "select * from `$trait` where id = '$material'";
        $result = query_redirect($query,$connection);
        assert_num_rows($result,1);
        $query = "insert into `$trait` values($id";
        foreach(mysql_fetch_array($result,MYSQL_ASSOC) as $key => $value) {
          if($key != "id") {
            $query .= ",'" . mysql_real_escape_string($value) . "'";
          }
        }
        $query .= ")";
        $result = query_redirect($query,$connection);
        assert_affected_rows($connection,1);
      }
    }
    else if($_REQUEST["action"] == "edit_desc") {
      if(!isset($_REQUEST["description"]))
        $_SESSION["description"] = $material;
    }
    else if($_REQUEST["action"] == "trait_public" &&
      isset($_REQUEST["trait"]))
    {
      $trait = $_REQUEST["trait"];
      assert_trait_owner($trait,$material,$_SESSION["uid"],$connection);
      $query = "update traits set trait_private = !trait_private where
        materialID = '$material' and userID = '${_SESSION["uid"]}'
        and table_name = '$trait'";
      query_redirect($query,$connection);
      assert_affected_rows($connection,1);
    }

    else if($_REQUEST["action"] == "trait_private" &&
      isset($_REQUEST["trait"]))
    {
      $trait = $_REQUEST["trait"];
      assert_trait_owner($trait,$material,$_SESSION["uid"],$connection);
      $query = "select id from traits where table_materialID = '$material' and
        table_name = '$trait' and userID != '${_SESSION["uid"]}'";
      $no_conf = (mysql_num_rows(query_redirect($query,$connection)) == 0);
      if(!$no_conf && !isset($_REQUEST["confirm"])) {
        $_SESSION["state"] = "confirm";
        $_SESSION["meta"] = array("material" => $material,
          "action" => "trait_private", "trait" => $trait);

        session_write_close();
        header("Location: http://mater.brlcad.org/admin/admin.php");
        exit;
      }
      else {
        if($no_conf || $_REQUEST["confirm"] == "1") {
          /*
            First we need to copy the values for any material that links to
            this trait before we go private. This needs to happen
            regardless who the owner is (unless it is ourself of course)
          */
          $query = "select * from `$trait` where id = '${_REQUEST["material"]}'";
          $result = query_redirect($query,$connection);
          $contents = array();
          while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
            foreach($row as $key => $value) {
              if($key != "id")
                $contents[$key] = $value;
            }
          }

          $query = "select id,materialID from traits
            where table_name = '$trait' and
            table_materialID = '${_REQUEST["material"]}' and 
            userID != '${_SESSION["uid"]}'";
          $result = query_redirect($query,$connection);
          while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
            $query = "update traits set table_materialID = materialID
              where id = '${row["id"]}'";
            query_redirect($query,$connection);
            assert_affected_rows($connection,1);

            $query = "update `$trait` set ";
            foreach($contents as $key => $value) {
              if($key != "id" && $key != "timestamp")
                $query .= "$key = '$value',";
            }
            $query .= "timestamp = now() where id = '${row["materialID"]}'";
            query_redirect($query,$connection);
            assert_affected_rows($connection,1);
          }

          $query = "update traits set trait_private = !trait_private where
            materialID = '$material' and userID = '${_SESSION["uid"]}'
            and table_name = '$trait'";

          query_redirect($query,$connection);
          assert_affected_rows($connection,1);
        }
      }
    }
    else if($_REQUEST["action"] == "drop" &&
      isset($_REQUEST["trait"]))
    {
      $trait = $_REQUEST["trait"];
      assert_trait_owner($trait,$material,$_SESSION["uid"],$connection);
      if(!isset($_REQUEST["confirm"])) {
        $_SESSION["state"] = "confirm";
        $_SESSION["meta"] = array("material" => $material,
          "action" => "drop", "trait" => $trait);

        session_write_close();
        header("Location: http://mater.brlcad.org/admin/admin.php");
        exit;
      }
      else {
        if($_REQUEST["confirm"] == "1") {
          /*
            First we need to copy the values for any material that links to
            this trait before we can drop it. This needs to happen
            regardless who the owner is (unless it is ourself of course)
          */
          $query = "select * from `$trait` where id = '${_REQUEST["material"]}'";
          $result = query_redirect($query,$connection);
          $contents = array();
          while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
            foreach($row as $key => $value) {
              if($key != "id")
                $contents[$key] = $value;
            }
          }

          $query = "select id,materialID from traits
            where table_name = '$trait' and
            table_materialID = '${_REQUEST["material"]}' and
            id != (select id from traits where materialID = '$material'
              and table_name = '$trait' and userID = '${_SESSION["uid"]}')";

          $result = query_redirect($query,$connection);
          while($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
            $query = "update traits set table_materialID = materialID
              where id = '${row["id"]}'";
            query_redirect($query,$connection);
            assert_affected_rows($connection,1);

            $query = "update `$trait` set ";
            foreach($contents as $key => $value) {
              if($key != "id" && $key != "timestamp")
                $query .= "$key = '$value',";
            }
            $query .= "timestamp = now() where id = '${row["materialID"]}'";
            query_redirect($query,$connection);
            assert_affected_rows($connection,1);
          }

          $query = "delete from traits where materialID = '$material'
            and table_name = '$trait' and userID = '${_SESSION["uid"]}'";

          query_redirect($query,$connection);
          assert_affected_rows($connection,1);

          $query = "delete from `$trait` where id = '$material'";
          query_redirect($query,$connection);
          assert_affected_rows($connection,1);
        }
      }
    }

    session_write_close();
    header("Location: http://mater.brlcad.org/admin/admin.php");
    exit;
  }

  /*
    Reset all session vars that are not used in some FSM, ie "state" var
    This is basically for the case where the user sets up the page to
    change something but doesn't complete the change (or does something to
    set up a change in something else). In these cases, handle the change
    setup and reset the session vars

    List all vars that you want reset here...
  */
  function reset_session_vars()
  {
    if(isset($_SESSION["modify"]))
      unset($_SESSION["modify"]);
    if(isset($_SESSION["description"]))
      unset($_SESSION["description"]);
    if(isset($_SESSION["update_error"]))
      unset($_SESSION["update_error"]);
    if(isset($_SESSION["update_error_msg"]))
      unset($_SESSION["update_error_msg"]);
  }
  
  function update_state()
  {
    /*
      $state is the pointer in a potential FSM
      $meta is any ancellary info that is passed
      to the particular node in the FSM
    */

    $state = $_SESSION["state"];
    $meta = (isset($_SESSION["meta"])?$_SESSION["meta"]:array());

    unset($_SESSION["state"]);
    unset($_SESSION["meta"]);

    switch ($state) {
      case "confirm":
        print_confirmation($meta);
        break;
    }
  }


  function print_confirmation($meta)
  {
    print("
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
  \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">
<html>
<head>
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">
  <title>Material Database Administration</title>
  <link rel=\"stylesheet\" type=\"text/css\" href=\"../css/admin.css\" />
</head>
<body class=\"text_center\">
  <form action=\"http://mater.brlcad.org/admin/admin.php\">
    <P>You are requesting to change information that will affect other users
      or may have unintended consequences.<br><br>
      If you make private a material or drop a trait that another material
      has linked to, this action will unlink any traits and copy the
      information to the other material.
      No information will be lost except the link but
      this action cannot be undone.<br><br>
      If you delete a material that contains traits that are not yours, the
      traits that are not yours along with your material will be lost forever.
      This may seem harsh
      but the alternative is polluting other users' environment with
      materials that are fragments of the original. By deleting
      the material altogether, the other users could be notified that the
      material no longer exists rather than being incomplete. <br><br>
      Please confirm that this is something that you wish to do.</P>");

    foreach($meta as $key => $value) {
      print("
    <input type=\"hidden\" name=\"$key\" value=\"$value\"></input>");
    }

    print("
    <input name=\"confirm\" type=\"radio\" value=\"1\"> Yep</input>
    <input name=\"confirm\" type=\"radio\" value=\"0\" checked> Nope</input>
    <input type=\"submit\" value=\"Submit\"></input>
  </form>
</body>
</html>");
  }


?>