<?
  function print_prologue()
  {
    print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
    print("<!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n");
    print("<plist version=\"1.0\">\n");
    print("<dict>\n");
  }

  function print_epilogue()
  {
    print("</dict>\n</plist>\n");
  }

  // must use 'true'/'false' notation for this to properly handle boolean
  // values. A 1 or 0 will be interpreted as numbers...
  function get_formatted_val($val)
  {
    if(is_numeric($val)) {
      if((float)$val != (int)$val)
        return "<real>$val</real>";
      else
        return "<integer>$val</integer>";
    }
    else if(is_bool($val)) {
      if($val == true)
        return "<true/>";
      else
        return "<false/>";
    }
    else
      return "<string>$val</string>";
  }

  function print_db($db)
  {
    $materials = $db["materials"];
    foreach($materials as $id => $mat_info) {

      //print_element($mat_info["name"]," ");
      print("  <key>${mat_info["name"]}</key>\n");
      $traitlist = $mat_info["traits"];
      foreach($traitlist as $key => $trait) {
        print("    <key>$key</key>\n");
        print("    <dict>\n");
        
        //unset all internal stuff
        if(isset($trait["timestamp"])) unset($trait["timestamp"]);
        if(isset($trait["userID"])) unset($trait["userID"]);
        if(isset($trait["trait_private"])) unset($trait["trait_private"]);
        if(isset($trait["materialID"])) unset($trait["materialID"]);
        foreach($trait as $name => $value) {
          print("      <key>$name</key>\n");
          print("      ".get_formatted_val($value). "\n");
        }
        print("    </dict>\n");
      }
    }
  }

?>